#!/bin/sh
source=$1; shift
dest=$1; shift
olddest=$1; shift
# Rest: additional parameters before directories

if test -z "$source"; then
  echo "Usage:"
  echo "  $0 sourcedir destinationdir [olddest] [extra rsync args]"
  echo "Note: The destination directories are supposed to live next to each"
  echo " other for hardlinking, so that ../oldest/file addresses the old"
  echo " variant of file within destinationdir/."
  exit
fi

# Experiment: preserving hardlinks via -H for the server backups.
# This is making versioned/hardlinked backups of versioned/hardlinked
# backups.
opts="-a -v -H --delete"
if test -z "$olddest"; then
  rsync $opts "$source/" "$dest"
else
  rsync $opts "$@" --link-dest="../$olddest" "$source/" "$dest"
fi
